<div class="container">
    <nav class="level">
        <!-- Left side -->
        <div class="level-left">
            <div class="level-item is-clickable is-hidden has-text-success" id="returnButton">
                <span class="icon">
                    <ion-icon name="caret-back-outline"></ion-icon>
                </span>
                <p class="level-item"><strong>Regresar</strong></p>
            </div>
        </div>

        <!-- Right side -->
        <div class="level-right">
            <p class="level-item"><a class="button is-info" id="reporteTotal">Total</a></p>
            <p class="level-item"><a class="button is-warning">Proyecci&oacute;n</a></p>
        </div>
    </nav>
    <div class="columns">
        <div class="column">
            <div class="overflow-x-auto mb-4">
                <!-- Tabla resultados -->
                <table class="table is-fullwidth has-background-white has-border-radius-10" id="resultadosTabla">
                    <thead>
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
            <!-- Card datos -->
            <div class="card card-info is-hidden">
                <div class="card-header">
                    <div class="card-header-title"></div>
                </div>
                <div class="card-content">
                </div>
            </div>
        </div>
    </div>
</div>


<script type="module">
    // Import the functions you need from the SDKs you need
    import { initializeApp } from "https://www.gstatic.com/firebasejs/9.23.0/firebase-app.js";
    // TODO: Add SDKs for Firebase products that you want to use
    // https://firebase.google.com/docs/web/setup#available-libraries

    // Your web app's Firebase configuration
    const firebaseConfig = {
        apiKey: "AIzaSyC-bZu5_F00-Fmf4L6JgPF0wk4v8VjkoN4",
        authDomain: "testrealdb-17286.firebaseapp.com",
        projectId: "testrealdb-17286",
        storageBucket: "testrealdb-17286.appspot.com",
        messagingSenderId: "974668284905",
        appId: "1:974668284905:web:4b352bdf6f22d3b01c0178"
    };

    // Initialize Firebase
    const app = initializeApp(firebaseConfig);

    import { getDatabase, ref, child, onValue, get, query, limitToFirst, limitToLast, orderByChild, orderByKey, orderByValue, startAt, startAfter, endAt, endBefore, equalTo } from "https://www.gstatic.com/firebasejs/9.23.0/firebase-database.js";

    // Get a reference to the database service
    const db = getDatabase();

    // documento on ready
    $(function() {
        
        // cargar datos
        cargarDatos();

        // Return Button regresa a cargarDatos()
        $('#returnButton').on('click', function(e) {
            cargarDatos();
            $(this).addClass('is-hidden');
        });

        // evento pais
        function cargarPaises(e) {
            const que = query(ref(db, '_Metadata'), orderByChild('Country Name'));

            get(que).then((snapshot) => {
                if (snapshot.exists()) {
                    let options = '<option>Países</option>';
                    snapshot.forEach((childSnapshot) => {
                        const childKey = childSnapshot.key;
                        const childData = childSnapshot.val();
                        options += `<option value="${childData['Country Code']}">${childData['Country Name']} : ${childData['Country Code']}</option>`;
                    }, {
                        onlyOnce: true
                    });
                    $('#paisSelect').html(options);
                } else {
                    toast("No data available");
                }
            }, {
                onlyOnce: true
            }).catch((error) => {
                console.error(error);
            });
        }
        // evento ingresos
        function cargarIngresos(e) {
            const que = query(ref(db, '_Metadata'));

            get(que).then((snapshot) => {
                if (snapshot.exists()) {
                    const data = snapshot.val();
                    const groups = data.reduce((acc, obj) => {
                        const key = obj.Income_Group;
                        if (!acc[key]) {
                            acc[key] = [];
                        }
                        acc[key].push(obj);
                        return acc;
                    }, {});
                    let options = '<option>Ingresos</option>';
                    for (const key in groups) {
                        options += `<option value="${key}">${key}</option>`;
                    }
                    $('#ingresosSelect').html(options);
                } else {
                    toast("No data available");
                }
            }, {
                onlyOnce: true
            }).catch((error) => {
                console.error(error);
            });

        }
        // Show modal when a row is clicked
        $('#resultadosTabla tbody').on('click', 'td.is-clickable', function() {
            const field = $(this).attr('data-field');
            const id = $(this).attr('data-id');
            cargaTableDatos(field,id);
        });
        
        // evento Datos para resultadosTabla thead y tbody
        function cargarDatos() {
            isloading(1);
            // Ocualtar card-info
            $('.card-info').addClass('is-hidden');
            const que = query(ref(db, '_Metadata'));

            get(que).then((snapshot) => {
                if (snapshot.exists()) {
                    const data = snapshot.val();
                    let head = '<tr>';
                    for (const key in data[2]) {
                        head += `<th>${key}</th>`; 
                    }
                    head += '</tr>';
                    // Add rows to table
                    let rows = '';
                    data.forEach((childSnapshot) => {
                        rows += '<tr>';
                        for (const key in childSnapshot) {
                            if (key == 'Country Name' || key == 'Country Code') {
                                rows += `<td class="is-clickable" data-field='${key}' data-id='${childSnapshot[key]}'>${childSnapshot[key]}</td>`;
                                continue;
                            } else if (key == 'Income_Group' || key == 'Region') {
                                rows += `<td class="is-clickable" data-field='${key}' data-id='${childSnapshot[key]}'>${childSnapshot[key]}</td>`;
                            }
                        }
                        rows += '</tr>';
                    }, {
                        onlyOnce: true
                    });

                    $('#resultadosTabla thead').html(head);
                    $('#resultadosTabla tbody').html(rows);
                    isloading(0);
                } else {
                    isloading(0);
                    toast("No data available");
                }
            }, {
                onlyOnce: true
            }).catch((error) => {
                console.error(error);
            });
        }

        function cargaTableDatos(field,id) {
            let querySrc = '_TOTL';
            if (field == 'Income_Group' || field == 'Region')
                querySrc = '_Metadata';
            const que = query(ref(db, querySrc), orderByChild(field), equalTo(id));

            get(que).then((snapshot) => {
                if (snapshot.exists()) {
                    // Activate return button
                    $('#returnButton').removeClass('is-hidden');
                    const data = snapshot.val();
                    let head = '';
                    let rows = '';
                    // Si es TOTL o META
                    switch (querySrc) {
                        case '_TOTL':
                            head += '<tr>';
                            let headToSort = [];
                            $.each(data, function(key, value) {
                                for (const key in value) {
                                    headToSort.push(key);
                                }
                            });
                            // Ordenamos en orden alfabetico inverso
                            headToSort.sort().reverse();
                            $.each(headToSort, function(key, value) {
                                head += `<th>${value}</th>`; 
                            });
                            head += '</tr>';
                            rows += '<tr>';
                            let bodyToSort = [];
                            $.each(data, function(key, value) {
                                for (const key in value) {
                                    bodyToSort.push(value[key]);
                                }
                            });
                            // Ordenamos en orden alfabetico inverso
                            bodyToSort.sort().reverse();
                            $.each(bodyToSort, function(key, value) {
                                rows += `<td>${value}</td>`;
                            });
                            rows += '</tr>';
                            // Carga la subtabla de datos similares en los demas locations de la base de datos
                            generaConsulta(field,id);
                            break;
                        case '_Metadata':
                            head += '<tr>';
                            $.each(data, function(key, value) {
                                for (const key in value) {
                                    head += `<th>${key}</th>`;
                                }
                                return false;
                            });
                            head += '</tr>';
                            $.each(data, function(key, value) {
                                rows += '<tr>';
                                for (const key in value) {
                                    rows += `<td>${value[key]}</td>`;
                                }
                                rows += '</tr>';
                            });
                            break;
                        default:
                            break;
                    }
                    // Add rows to table
                    $('#resultadosTabla thead').html(head);
                    $('#resultadosTabla tbody').html(rows);

                } else {
                    toast("No data available");
                }
            }, {
                onlyOnce: true
            }).catch((error) => {
                console.error(error);
            });
        }

        // genera la consulta
        function generaConsulta(field, id) {
            isloading(1);
            get(ref(db)).then((snapshot) => {
                if (snapshot.exists()) {
                    const data = snapshot.val();
                    const locations = Object.keys(data);
                    // Muestra la card-info
                    $('.card-info').removeClass('is-hidden');
                    // Cambia el title
                    $('.card-info .card-header-title').html('Registros Disponibles: ' + locations.length);
                    let template = '<ul>';
                    $.each(locations, function(key, value) {
                        // Alimentala con los nombres de las locations
                        template += '<li>';
                            template += `<span class="is-clickable query-locations" data-field='${field}' data-id='${id}'>${value}</span>`;
                        template += '</li>';
                    })
                    $('.card-info .card-content').html(template);

                    // Query locations
                    $('.query-locations').on('click', function() {
                        const location = $(this).text();
                        const field = $(this).attr('data-field');
                        const id = $(this).attr('data-id');
                        const que = query(ref(db, location), orderByChild(field), equalTo(id));
                        // Consultas a Firebase con Promise
                        consultasFirebase(que).then(function(result) {
                            // Lee result
                            
                        }).catch(function(error) {
                            console.log(error);
                        });
                    });
                    isloading(0);
                } else {
                    isloading(0);
                    toast("No data available");
                }
            }, {
                onlyOnce: true
            }).catch((error) => {
                console.error(error);
            });
        }


        // Reporte Total
        $('#reporteTotal').on('click', function(e) {
            e.preventDefault();
            // Obtenemos los lacation disponibles
            get(ref(db)).then((snapshot) => {
                if (snapshot.exists()) {
                    $('.select').removeClass('is-loading');
                    const data = snapshot.val();
                    const locations = Object.keys(data);
                    $.each(locations, function(key, value) {
                        console.log(value);
                        const que = query(ref(db, value));
                        // Consultas a Firebase con Promise
                        consultasFirebase(que).then(function(result) {
                            
                        }).catch(function(error) {
                            console.log(error);
                        });
                    })
                    
                } else {
                    toast("No data available");
                }
            }, {
                onlyOnce: true
            }).catch((error) => {
                console.error(error);
            });
            
        });
        
        function consultasFirebase(query) {
            // Return a Promise to allow asynchronous processing
            return new Promise(function(resolve, reject) {
                // Get the data from the database
                get(query).then((snapshot) => {
                    if (snapshot.exists()) {
                        const data = snapshot.val();
                        console.log(data)
                        resolve(data);
                    } else {
                        toast("No data available");
                    }
                }, {
                    onlyOnce: true
                }).catch((error) => {
                    console.error(error);
                });
                // Resolve the Promise with the modified object
            });
        }


    }());
</script>
